package org.processmining.logfiltering.parameters;

import org.deckfour.xes.classification.XEventClassifier;
import org.deckfour.xes.classification.XEventNameClassifier;
import org.processmining.basicutils.parameters.impl.PluginParametersImpl;
public class MatrixFilterParameter extends PluginParametersImpl {
	
	private double probabilityOfRemoval = 0.1;
	private int SubsequenceLength = 2;
	private FilterLevel FilteringMethod = FilterLevel.TRACE;
	private XEventClassifier EventAttribute = new XEventNameClassifier();
	private FilterSelection FilteringSelection = FilterSelection.REMOVE;
	private AdjustingType AdjustingThresholdMethod= AdjustingType.None;
	private ProbabilityType ProbabilitycomutingMethod= ProbabilityType.DIRECT;
	
	public MatrixFilterParameter(){
		super();
		
	}
			
	public AdjustingType getAdjustingThresholdMethod() {
		return AdjustingThresholdMethod;
	}

	public ProbabilityType getProbabilitycomutingMethod() {
		return ProbabilitycomutingMethod;
	}

	public void setProbabilitycomutingMethod(ProbabilityType probabilitycomutingMethod) {
		ProbabilitycomutingMethod = probabilitycomutingMethod;
	}

	public void setAdjustingThresholdMethod(AdjustingType adjustingThresholdMethod) {
		AdjustingThresholdMethod = adjustingThresholdMethod;
	}

	public FilterSelection getFilteringSelection() {
		return FilteringSelection;
	}

	public void setFilteringSelection(FilterSelection filteringSelection) {
		FilteringSelection = filteringSelection;
	}

	public MatrixFilterParameter(double probabilityOfRemoval, AdjustingType  adjustingThresholdMethod,int subsequencelenth ,FilterLevel filteringmethod, FilterSelection filteringSelection, 
				ProbabilityType probabilitycomutingMethod	,XEventClassifier eventattribute) {
		super();
		this.probabilityOfRemoval = probabilityOfRemoval;
		this.FilteringMethod= filteringmethod;
		this.EventAttribute = eventattribute;
		this.FilteringSelection = filteringSelection;
		this.SubsequenceLength=subsequencelenth;
		this.AdjustingThresholdMethod= adjustingThresholdMethod;
		this.ProbabilitycomutingMethod=probabilitycomutingMethod;
	}

	public int getSubsequenceLength() {
		return SubsequenceLength;
	}

	public void setSubsequenceLength(int subsequenceLength) {
		SubsequenceLength = subsequenceLength;
	}

	public MatrixFilterParameter(double probabilityOfRemoval, FilterLevel filteringmethod , XEventClassifier eventattribute) {
		super();
		this.probabilityOfRemoval = probabilityOfRemoval;
		this.FilteringMethod= filteringmethod;
		this.EventAttribute = eventattribute;
	}
	public MatrixFilterParameter( XEventClassifier eventattribute) {
		super();
		this.EventAttribute = eventattribute;
	}

	public MatrixFilterParameter(int subsequencelenth, XEventClassifier eventattribute) {
		super();
		this.EventAttribute = eventattribute;
		this.SubsequenceLength=subsequencelenth;
	}

	public XEventClassifier getEventClassifier() {
		return EventAttribute;
	}

	public void setEventClassifier(XEventClassifier eventAttribute) {
		EventAttribute = eventAttribute;
	}

	public FilterLevel getFilterLevel() {
		return FilteringMethod;
	}

	public void setFilterLevel(FilterLevel filteringMethod) {
		FilteringMethod = filteringMethod;
	}

	public double getProbabilityOfRemoval() {
		return probabilityOfRemoval;
	}

	public void setProbabilityOfRemoval(double probabilityOfRemoval) {
		this.probabilityOfRemoval = probabilityOfRemoval;
	}

	

	

}
