package org.processmining.logfiltering.visFilteringAlgorithms;

import java.util.HashMap;
import java.util.Map;

public class FilteringAlgorithmFactory {
	public static enum algorithms { NO, VARIANT,MATRIX,AFA };
	public Map<String, FilteringAlgorithmFactory.algorithms> algorithmsLabels  = new HashMap<String, FilteringAlgorithmFactory.algorithms>();
	
	public FilteringAlgorithmFactory() {
		algorithmsLabels = new HashMap<String, FilteringAlgorithmFactory.algorithms>();
		
		// add the labels for each algorithm
		algorithmsLabels.put("No filtering", FilteringAlgorithmFactory.algorithms.NO);
		algorithmsLabels.put("Variant filter", FilteringAlgorithmFactory.algorithms.VARIANT);
		algorithmsLabels.put("Matrix filter", FilteringAlgorithmFactory.algorithms.MATRIX);
		algorithmsLabels.put("AFA filter", FilteringAlgorithmFactory.algorithms.AFA);
		
	}
	
	public ApplyFilteringAlgorithm getFilteringAlgorithm(FilteringAlgorithmFactory.algorithms filteringAlgorithmDescription) {
		if (filteringAlgorithmDescription.equals(FilteringAlgorithmFactory.algorithms.NO)) {
			return new NoFilteringAlgorithm();
		}
		else if (filteringAlgorithmDescription.equals(FilteringAlgorithmFactory.algorithms.VARIANT)) {
			return new VariantFilteringAlgorithm();
		}
		else if (filteringAlgorithmDescription.equals(FilteringAlgorithmFactory.algorithms.MATRIX)) {
			return new MatrixFilteringAlgorithm();
		}
		else if (filteringAlgorithmDescription.equals(FilteringAlgorithmFactory.algorithms.AFA)) {
			return new AFAFilteringAlgorithm();
		}
		return null;
	}
}
