package org.processmining.logfiltering.visMiningAlgorithms;

import java.util.HashMap;
import java.util.Map;

public class MiningAlgorithmsFactory {
	public static enum algorithms { ALPHA, INDUCTIVE };
	public Map<String, MiningAlgorithmsFactory.algorithms> algorithmsLabels = new HashMap<String, MiningAlgorithmsFactory.algorithms>();
	
	public MiningAlgorithmsFactory() {
		algorithmsLabels = new HashMap<String, MiningAlgorithmsFactory.algorithms>();
		// add the labels for each algorithm
		algorithmsLabels.put("Alpha Miner", MiningAlgorithmsFactory.algorithms.ALPHA);
		algorithmsLabels.put("Inductive Miner", MiningAlgorithmsFactory.algorithms.INDUCTIVE);
	}
	
	public ApplyMiningAlgorithm getMiningAlgorithm(MiningAlgorithmsFactory.algorithms miningAlgorithmDescription) {
		if (miningAlgorithmDescription.equals(algorithms.ALPHA)) {
			return new ApplyAlphaAlgorithm();
		}
		else if (miningAlgorithmDescription.equals(algorithms.INDUCTIVE)) {
			return new ApplyInductiveMiner();
		}
		return null;
	}
}
